"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const node_request_context_1 = require("node-request-context");
class RequestContext {
    constructor(em) {
        this.em = em;
        this.id = Math.random();
    }
    static create(em, next) {
        const context = new RequestContext(em.fork());
        const namespace = node_request_context_1.getNamespace(RequestContext.NAMESPACE) || node_request_context_1.createNamespace(RequestContext.NAMESPACE);
        namespace.run(() => {
            namespace.set(RequestContext.name, context);
            next();
        });
    }
    static currentRequestContext() {
        const namespace = node_request_context_1.getNamespace(RequestContext.NAMESPACE);
        return namespace ? namespace.get(RequestContext.name) : null;
    }
    static getEntityManager() {
        const context = RequestContext.currentRequestContext();
        return context ? context.em : null;
    }
}
RequestContext.NAMESPACE = 'mikro-orm-context';
exports.RequestContext = RequestContext;
